local PlayerTypeRed = 0
local PlayerTypeBlack = 1
local PlayerTypePink = 2

local StatusPlay = 0;

function win()
	Game_changeBackgroundMusic("Main.mp3", "the-end.wav", false);
	--m_finisher:setIsVisible(false);
	Instance():getLevel():win();
	if XmlProfilesManager_getInstance():isAchievementRelease(13) == false then
        Instance():getLevel():ShowAchivement(13)
    end
end

function playFight() 
    fight = CCSprite_spriteWithFileName("pack1/level20/fight.png");
	fight:setPositionX(ConfigData_Instance():getWidth() / 2);
    fight:setPositionY(ConfigData_Instance():getHeight() / 2);
    Instance():getLevel():addChild(fight);
    
    local scale = ConfigData_Instance():getScale();
	
	local array1 = CCArray_array();
	array1:addObject(CCRotateBy_actionWithDuration(0.2, 450))
	array1:addObject(CCRotateBy_actionWithDuration(0.2, 2))
	array1:addObject(CCFadeOut_actionWithDuration(1.2))
	
	local array2 = CCArray_array();
	array2:addObject(CCScaleTo_actionWithDuration(0.2, 0.9 * scale, 1.1 * scale))
	array2:addObject(CCDelayTime_actionWithDuration(0.2))
    array2:addObject(CCScaleTo_actionWithDuration(0.2, 1.1 * scale, 0.9 * scale))
	array2:addObject(CCDelayTime_actionWithDuration(0.12))
	array2:addObject(CCScaleTo_actionWithDuration(0.2, 0.9 * scale, 1.1 * scale))
	array2:addObject(CCDelayTime_actionWithDuration(0.1))
	array2:addObject(CCScaleTo_actionWithDuration(0.2, 1.0 * scale, 1.0 * scale))
	array2:addObject(CCDelayTime_actionWithDuration(0.1))
	array2:addObject(CCSpawn_actionsWithArray(array1))
	
	fight:runAction(CCSequence_actionsWithArray(array2))
end


function playHelp()
	help:setIsVisible(true);
	
	local scale = ConfigData_Instance():getScale();
	
	local array1 = CCArray_array();
	array1:addObject(CCRotateTo_actionWithDuration(0.12, -30))
	array1:addObject(CCRotateTo_actionWithDuration(0.12, 30))
	array1:addObject(CCRotateTo_actionWithDuration(0.12, -30))
	array1:addObject(CCRotateTo_actionWithDuration(0.12, 30))
	array1:addObject(CCRotateTo_actionWithDuration(0.12, -30))
    array1:addObject(CCRotateTo_actionWithDuration(0.12, 30))
    array1:addObject(CCRotateTo_actionWithDuration(0.12, -30))
	array1:addObject(CCRotateTo_actionWithDuration(0.12, 30))
	array1:addObject(CCRotateTo_actionWithDuration(0.12, -30))
    array1:addObject(CCRotateTo_actionWithDuration(0.12, 30))
    array1:addObject(CCRotateTo_actionWithDuration(0.12, -30))
	array1:addObject(CCRotateTo_actionWithDuration(0.08, 0))
	

	local array2 = CCArray_array();
	array2:addObject(CCFadeIn_actionWithDuration(2.0))
	array2:addObject(CCScaleTo_actionWithDuration(2.0, 1.2 * scale))
	array2:addObject(CCSequence_actionsWithArray(array1))
	
	local array3 = CCArray_array();
	array3:addObject(CCFadeOut_actionWithDuration(0.3))
	array3:addObject(CCScaleTo_actionWithDuration(0.3, 0.0 * scale))
	
	local array4 = CCArray_array();
	array4:addObject(CCDelayTime_actionWithDuration(0.2))
	array4:addObject(CCSpawn_actionsWithArray(array2))
	array4:addObject(CCSpawn_actionsWithArray(array3))
	
	
	help:runAction(CCSequence_actionsWithArray(array4))
end

function __init()
    m_gamaWin = false;
	m_finisher = nil;
	killBoss = false;
	achievementUnlocked = 0
	Instance():getLevel():buttonsInit();
	Instance():getLevel():flagsInit();
    Instance():getLevel():createSprite("back1", "back1");
	

    killer1Body = Instance():getLevel():createSpriteAndBody("killer1", "killer");
	killer2Body = Instance():getLevel():createSpriteAndBody("killer2", "killer");
	local door1Body = Instance():getLevel():createSpriteAndBody("door1", "door1");
	local door2Body = Instance():getLevel():createSpriteAndBody("door2", "door2");

	door1 = GameObjects_Instance():createObjectPlatform("door1", door1Body, nil)
	Instance():getLevel():createObject(door1)
	
	door2 = GameObjects_Instance():createObjectPlatform("door2", door2Body, nil)
	Instance():getLevel():createObject(door2)
			
			
    land1Body = Instance():getLevel():createSpriteAndBody("land1", "land1");
    local back2 = Instance():getLevel():createSprite("back2", "back2");
    
    local door3Body = Instance():getLevel():createSpriteAndBody("door3", "door3");
	local door4Body = Instance():getLevel():createSpriteAndBody("door4", "door4");

	door3 = GameObjects_Instance():createObjectPlatform("door3", door3Body, nil)
	Instance():getLevel():createObject(door3)
	
	door4 = GameObjects_Instance():createObjectPlatform("door4", door4Body, nil)
	Instance():getLevel():createObject(door4)

	land2Body = Instance():getLevel():createSpriteAndBody("land2", "land2");
	nail1Body = Instance():getLevel():createSpriteAndBody("nail1", "nail1");

	for i = 0, 9 do
      Instance():getLevel():createSpriteAndBody("rope"..i, "rope");
	end
	Instance():getLevel():createSpriteAndBody("magnet1", "magnet1");

	if (Instance():getLevel():getPlayerType() ~= PlayerTypePink) then
		girl = GameObjects_Instance():createObjectPlayer("pinkMC", PlayerTypePink, Instance():getLevel());
	else 
		girl = GameObjects_Instance():createObjectPlayer("pinkMC", PlayerTypePink, Instance():getLevel());
	end
	girl:retain();
	

	cageBody = Instance():getLevel():createSpriteAndBody("cage1", "cage_0001");
	Instance():getLevel():playerInit();
	hideLand1 = Instance():getLevel():createSprite("tunel1", "tunel1");
	hideLand2 = Instance():getLevel():createSprite("tunel2", "tunel2");
	Instance():getLevel():starsInit();
	

	local killer1Joint = b2JointWrapper_Instance():createb2RevoluteJoint(killer1Body:GetJointList().joint);
	killer1Joint:EnableMotor(true);
	killer1Joint:SetMaxMotorTorque(100);
	killer1Joint:SetMotorSpeed(-3);
	local killer2Joint = b2JointWrapper_Instance():createb2RevoluteJoint(killer2Body:GetJointList().joint);
	killer2Joint:EnableMotor(true);
	killer2Joint:SetMaxMotorTorque(100);
	killer2Joint:SetMotorSpeed(3);
	
	
	cageJoint = cageBody:GetJointList().joint;

	door1:setState(0);
	door2:setState(0);
	door3:setState(0);
	door4:setState(0);
	hideLand1:setIsVisible(true);
	hideLand2:setIsVisible(true);
	couldKick = 0.0;

    cageDestroy = CCAnimation_animation()
	cageDestroy:setName("cageDestroy")
	cageDestroy:setDelay(0.0583)
	cageDestroy:retain()
	for i = 2, 9 do 
		local anim = CCSpriteFrameCache_sharedSpriteFrameCache():spriteFrameByName("cage_000"..i..".png");
        cageDestroy:addFrame(anim)
	end
	
	fightDelay = 2.0;
	help = CCSprite_spriteWithFileName("pack1/level20/help.png");
	help:setPositionX(ConfigData_Instance():getWidth() / 2);
    help:setPositionY(ConfigData_Instance():getHeight() / 2);
	Instance():getLevel():addChild(help);
	help:setIsVisible(false);
	help:setScale(0.0);
	boss = nil;
	
	if killBoss then
	    if (help:getIsVisible() == false) then
			playHelp();
			Game_playBackgroundMusic("Main.mp3", true); 
			door1:setState(1);
			door2:setState(1);
			door3:setState(1);
			door4:setState(1);
			hideLand1:setIsVisible(false);
			hideLand2:setIsVisible(false);
		end
	else
		Game_playBackgroundMusic("Battle.mp3", true);
		playFight();

		if (Instance():getLevel():getPlayerType() ~= PlayerTypeBlack) then
		    boss = GameObjects_Instance():createObjectPlayer("blackMC", PlayerTypeBlack, Instance():getLevel());
		else
		    boss = GameObjects_Instance():createObjectPlayer("blackMC", PlayerTypeRed, Instance():getLevel());
		end
		boss:retain();
        
		Instance():getLevel():getPlayer():setControl(false);
		
		if (Instance():getLevel():getPlayerType() == PlayerTypeRed) then
			redAvatar = Instance():getLevel():createSprite("redAvatar", "redAvatar");
			redHealth = Instance():getLevel():createSprite("redHealth", "redHealth");
		elseif(Instance():getLevel():getPlayerType() == PlayerTypeBlack) then
			redAvatar = Instance():getLevel():createSprite("redAvatar", "blackAvatar");
			redHealth = Instance():getLevel():createSprite("redHealth", "blackHealth");
		    redAvatar:setScaleX(redAvatar:getScaleX()*-1);
		elseif(Instance():getLevel():getPlayerType() == PlayerTypePink) then
			redAvatar = Instance():getLevel():createSprite("redAvatar", "pinkAvatar");
			redHealth = Instance():getLevel():createSprite("redHealth", "pinkHealth");
		end
		
		if (Instance():getLevel():getPlayerType() ~= PlayerTypeBlack) then
			bossAvatar = Instance():getLevel():createSprite("blackAvatar", "blackAvatar");
			bossHealth = Instance():getLevel():createSprite("blackHealth", "blackHealth");
		else
			bossAvatar = Instance():getLevel():createSprite("blackAvatar", "redAvatar");
			bossHealth = Instance():getLevel():createSprite("blackHealth", "redHealth");
			bossAvatar:setScaleX(bossAvatar:getScaleX()*-1);
		end
		
		redFrame = Instance():getLevel():createSprite("redFrame", "healthFrame");
		bossFrame = Instance():getLevel():createSprite("blackFrame", "healthFrame");
		
		if(ConfigData_Instance():getWidth() == 2048 and ConfigData_Instance():getHeight() == 1536) then
			redHealth:setPositionX(ConfigData_Instance():get_XX(13));
			redFrame:setPositionX(ConfigData_Instance():get_XX(11.5));
			redAvatar:setPositionX(ConfigData_Instance():get_XX(35));
			bossHealth:setPositionX(ConfigData_Instance():getWidth() - ConfigData_Instance():get_XX(123));
			bossFrame:setPositionX(ConfigData_Instance():getWidth() - ConfigData_Instance():get_XX(124));
			bossAvatar:setPositionX(ConfigData_Instance():getWidth() - ConfigData_Instance():get_XX(35));
		end
	end 

end	
	
__init()

function update(dt)

    if (fightDelay > 0) then
        fightDelay = fightDelay - dt; 
    else 
        Instance():getLevel():getPlayer():setControl(true);
	end
	
    if (boss and not killBoss and Instance():getLevel():getPlayer():getControl()) then
		couldKick = couldKick + dt;
		boss:setUp(true);
		
		if (boss:getSprite():getPositionX() > Instance():getLevel():getPlayer():getSprite():getPositionX()) then
			boss:setLeft(true);
			boss:setRight(false);
		else
			boss:setLeft(false);
			boss:setRight(true);
		end
		
		if (Instance():getLevel():isTouch(Instance():getLevel():getPlayer():getBody(), boss:getBody()) == 1 and couldKick > 0.5) then
			if (Instance():getLevel():getPlayer():getSprite():getPositionY() > boss:getSprite():getPositionY()) then
				boss:setHealth(boss:getHealth() - (2 * Instance():getLevel():getPlayer():getBody():GetLinearVelocity():Length()));
				Game_playEffect("Kick1");
			else
				Instance():getLevel():getPlayer():setHealth(Instance():getLevel():getPlayer():getHealth() - (2 * boss:getBody():GetLinearVelocity():Length()));
				Game_playEffect("Kick2");
			end
			
			couldKick = 0.0;
		end
		
		if(ConfigData_Instance():getWidth() == 2048 and ConfigData_Instance():getHeight() == 1536) then
			if(Instance():getLevel():getPlayer():getSprite():getPositionX() + ConfigData_Instance():getWidth() / 2 <= ConfigData_Instance():get_XX(530) 
					and Instance():getLevel():getPlayer():getSprite():getPositionX() - ConfigData_Instance():getWidth() / 2 >= -ConfigData_Instance():get_XX(0.5)) then
				redHealth:setPositionX(ConfigData_Instance():get_XX(13) + Instance():getLevel():getPlayer():getSprite():getPositionX() - ConfigData_Instance():getWidth() / 2);
				redFrame:setPositionX(ConfigData_Instance():get_XX(11.5) + Instance():getLevel():getPlayer():getSprite():getPositionX() - ConfigData_Instance():getWidth() / 2);
				redAvatar:setPositionX(ConfigData_Instance():get_XX(35) + Instance():getLevel():getPlayer():getSprite():getPositionX() - ConfigData_Instance():getWidth() / 2);
				bossHealth:setPositionX(Instance():getLevel():getPlayer():getSprite():getPositionX() + ConfigData_Instance():getWidth() / 2 - ConfigData_Instance():get_XX(123));
				bossFrame:setPositionX(Instance():getLevel():getPlayer():getSprite():getPositionX() + ConfigData_Instance():getWidth() / 2 - ConfigData_Instance():get_XX(124));
				bossAvatar:setPositionX(Instance():getLevel():getPlayer():getSprite():getPositionX() + ConfigData_Instance():getWidth() / 2 - ConfigData_Instance():get_XX(35));
			end
		end
		
		redHealth:setScaleX(Instance():getLevel():getPlayer():getHealth() / 100 * ConfigData_Instance():getScale());
		bossHealth:setScaleX(boss:getHealth() / 100 * ConfigData_Instance():getScale());
		if (redHealth:getScaleX() < 0.0) then redHealth:setScaleX(0.0); end
		if (bossHealth:getScaleX() < 0.0) then bossHealth:setScaleX(0.0); end
 	end
	
	if (killBoss and not m_gamaWin) then
		if (nail1Body:GetPosition().y > ConfigData_Instance():getNew_Y(-160) / ConfigData_Instance():get_PTM_RATIO() and cageJoint) then
		    local pV = nail1Body:GetLinearVelocity()
	        pV.x = 0;
	        pV.y = -0.85;
			nail1Body:SetLinearVelocity(pV);
		else
			local pV = nail1Body:GetLinearVelocity()
	        pV.x = 0;
	        pV.y = 0.85;
			nail1Body:SetLinearVelocity(pV);
			if (cageJoint) then
			    Instance():getLevel():getWorld():DestroyJoint(cageJoint)
				cageJoint = nil;
			end
		end
		
		if (cageBody and (Instance():getLevel():isTouch(cageBody, land1Body) == 1  or Instance():getLevel():isTouch(cageBody, killer1Body) == 1 or Instance():getLevel():isTouch(cageBody, killer2Body) == 1)) then					
			getBodySprite(cageBody):runAction(CCAnimate_actionWithAnimation(cageDestroy, false))
			Instance():getLevel():getWorld():DestroyBody(cageBody);
			cageBody = NULL;		
		end
		
		if (Instance():getLevel():isTouch(Instance():getLevel():getPlayer():getBody(), girl:getBody()) == 1) then
			if (Instance():getLevel():getStatus() == StatusPlay) then
				girl:makePinkFun();
				Game_playEffect("Kiss");
			end
			m_gamaWin = true;
			
			
			--local m_finisher = CCSprite()
			--m_finisher:setPosition(0, 0);
			--m_finisher:setAnchorPoint(0, 0);

			Instance():getLevel():getPlayer():makePinkFun();
	
			Game_changeBackgroundMusic("the-end.wav", "Main.mp3", false);
			
			
			--[[anim = CCAnimation_animation()
            anim:setName("outro")
            anim:setDelay(2.0)
            for i = 0, 4 do 
                anim:addFrameWithFileName("outro_"..i..".png");
            end--]]
	        --Instance():getLevel():addChild(m_finisher)
	        
	        --local array1 = CCArray_array();
	        --array1:addObject(CCAnimate_actionWithAnimation(anim, false))
            --array1:addObject(CCCallFunc_actionWithTarget(Instance():getLevel(), win))

			--m_finisher:runAction(CCSequence_actionsWithArray(array1));
			
			win();
		end
		
		if (not girl:getLive()) then
			Instance():getLevel():lose();
		end	
		if (Instance():getLevel():isTouch(killer1Body, girl:getBody()) == 1
                or Instance():getLevel():isTouch(killer2Body, girl:getBody()) == 1) then
			girl:killPlayer();
		end
		if (Instance():getLevel():isTouch(killer1Body, Instance():getLevel():getPlayer():getBody()) == 1 or
                 Instance():getLevel():isTouch(killer2Body, Instance():getLevel():getPlayer():getBody()) == 1) then
			Instance():getLevel():getPlayer():killPlayer();
			boss = nil;
			Instance():getLevel():lose();
		end
	end
	
	if (killBoss == false and not boss:getLive()) then
		if (help:getIsVisible() == false) then
			playHelp();
			Game_playBackgroundMusic("Main.mp3", true); 
		end
		killBoss = true;

		door1:setState(1);
		door2:setState(1);
		door3:setState(1);
		door4:setState(1);
		hideLand1:setIsVisible(false);
		hideLand2:setIsVisible(false);

		redAvatar:setIsVisible(false);
		redHealth:setIsVisible(false);
		redFrame:setIsVisible(false);
		bossAvatar:setIsVisible(false);
		bossHealth:setIsVisible(false);
		bossFrame:setIsVisible(false);
	end
end


function destroy()
	fight = nil;
	help = nil;
	killer1Body = nil;
	killer2Body = nil;
	door1 = nil;
	door2 = nil;
	door3 = nil;
	door4 = nil;
	land1Body = nil;
	land2Body = nil;
	nail1Body = nil;
	girl = nil;
	cageBody = nil;
	hideLand1 = nil;
	hideLand2 = nil;
	cageJoint = nil;
	cageDestroy:release();
	boss = nil;
	redAvatar = nil;
	redHealth = nil;
	redFrame = nil;
	bossAvatar = nil;
	bossHealth = nil;
	bossFrame = nil;
end



